# -*- coding: utf-8 -*-

from core.libs import *

QLT = Qualities({
    Qualities.rip: ['DVDRip', 'dvdrip', 'rhdtv', 'HDRip'],
    Qualities.hd_full: ['1080p', 'BluRay-1080p', 'BDremux-1080p', 'FullBluRay', 'MicroHD-1080p'],
    Qualities.uhd: ['4K-HDR', '4K'],
    Qualities.hd: ['BluRay-720p', 'hdtv', '720p'],
    Qualities.scr: ['dvdscr', 'BR-Screener '],
    Qualities.sd: ['sd']
})

HOST = 'http://www.mejortorrent.com'

def mainlist(item):
    logger.trace()
    itemlist = list()

    # SubMenu Peliculas
    new_item = item.clone(
        type='label',
        label="Películas",
        category='movie',
        thumb='thumb/movie.png',
        icon='icon/movie.png',
        poster='poster/movie.png'
    )
    itemlist.append(new_item)

    new_item = new_item.clone(
        action="newest_movies",
        content_type='movies',
        type="item"
    )

    itemlist.append(new_item.clone(
        label="Novedades SD",
        group=True,
        url=HOST + '/torrents-de-peliculas.html'))

    itemlist.append(new_item.clone(
        label="Novedades HD",
        group=True,
        url=HOST + '/torrents-de-peliculas-hd-alta-definicion.html'))


    #SubMenu Series
    new_item = item.clone(
        type='label',
        label="Series",
        category='tvshow',
        thumb='thumb/tvshow.png',
        icon='icon/tvshow.png',
        poster='poster/tvshow.png',
    )
    itemlist.append(new_item)

    new_item = new_item.clone(
        action="newest_episodes",
        content_type='episodes',
        type="item"
    )

    itemlist.append(new_item.clone(
        label="Nuevos episodios SD",
        group=True,
        url=HOST + '/torrents-de-series.html',
        quality='sd'))

    itemlist.append(new_item.clone(
        label="Nuevos episodios HD",
        group=True,
        url=HOST + '/torrents-de-series-hd-alta-definicion.html'))


    return itemlist


def newest_movies(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    # Extraemos bloque_noticia
    patron = "<td><div align='justify'><center>(.*?)</td>"
    for noticia in scrapertools.find_multiple_matches(data,patron):
        # Obtenemos las urls y los posters incluidos en cada noticia
        patron = '<a href="([^"]+)"><img src="([^"]+)'
        for url, poster in scrapertools.find_multiple_matches(noticia, patron):
            # Con ayuda de la url obtenemos el titulo y la calidad de cada pelicula
            patron = '%s">([^<]+)</a>\s*<b>([^<]+)</b>' % url
            title, quality = scrapertools.find_single_match(noticia, patron)
            title = title.replace(quality, '').strip()
            quality = quality.replace('(','').replace(')','').strip()

            itemlist.append(item.clone(
                title=title,
                label=title,
                url= HOST + url,
                type="movie",
                content_type="servers",
                poster= HOST + poster,
                action="findvideos",
                quality=QLT.get(quality)
                ))

    # Paginador
    if len(itemlist) > 40:
        if not item.page:
            itemlist = itemlist[:len(itemlist) / 2]
            next_url = ""
            itemlist.append(item.clone(
                type='next',
                page=True
            ))
        else:
            itemlist = itemlist[len(itemlist) / 2:]
            next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    else:
        next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    if next_url:
        next_url = HOST + next_url
        itemlist.append(item.clone(
            url=next_url,
            type='next',
            page=False
        ))

    return itemlist


def newest_episodes(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    # Extraemos bloque_noticia
    patron = "<td><div align='justify'><center>(.*?)</td>"
    for noticia in scrapertools.find_multiple_matches(data, patron):
        # Obtenemos las urls y los posters incluidos en cada noticia
        patron = '<a href="([^"]+)"><img src="([^"]+)'
        for url, poster in scrapertools.find_multiple_matches(noticia, patron):
            # Con ayuda de la url obtenemos el titulo_temporada y el capitulo
            patron = '%s">([^<]+)</a>\s*<b>([^<]+)</b>' % url
            title_season, episode = scrapertools.find_single_match(noticia, patron)
            tvshowtitle, season = scrapertools.find_single_match(title_season, "(?i)(.*?) - ([0-9,M]+)")
            quality = scrapertools.find_single_match(title_season, "\[([^\]]+)")

            # si es miniserie
            season = int(season.lower().replace('m', '1'))

            new_item = item.clone(
                tvshowtitle=tvshowtitle.strip(),
                label=tvshowtitle.strip(),
                url=HOST + url,
                action="findvideos",
                thumb=HOST + poster,
                season=season,
                type='episode',
                content_type='servers',
                quality = QLT.get(quality) if quality else item.quality
            )

            num_episode = scrapertools.find_multiple_matches(episode, "(\d+)")
            num_episode = [int(n) for n in num_episode]
            new_item.episode = num_episode[0]

            if len(num_episode) > 1:
                if 'al' in episode and len(num_episode) == 2:
                    multi_episodes = range(num_episode[0], num_episode[1] + 1)
                else:
                    multi_episodes = num_episode

                if 'serie-episodio-descargar-torrent' in url:
                    # Verdaderos multi_episodess
                    new_item.multi_episodes = multi_episodes

                elif 'serie-descargar-torrents' in url:
                    # Falsos multi_episodess
                    new_item.multi_episodes = multi_episodes
                    new_item.content_type = 'episodes'
                    #new_item.action='episodes' # Esto lista toda la temporada
                    new_item.action='filter_multi_episodes' # Esto obtiene solo los episodios indicados

            itemlist.append(new_item)

    # Paginador
    if len(itemlist) > 40:
        if not item.page:
            itemlist = itemlist[:len(itemlist) / 2]
            next_url = ""
            itemlist.append(item.clone(
                type='next',
                page=True
            ))
        else:
            itemlist = itemlist[len(itemlist) / 2:]
            next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    else:
        next_url = scrapertools.find_single_match(data, "</span> <a href='(.*?)'")

    if next_url:
        next_url = HOST + next_url
        itemlist.append(item.clone(
            url=next_url,
            type='next',
            page=False
        ))

    return itemlist


def filter_multi_episodes(item):
    itemlist= list()
    multi_episodes = item.multi_episodes
    item.multi_episodes=[]

    for new_item in episodes(item):
        if new_item.multi_episodes:
            # Verdadero multi_episodes
            if set(multi_episodes).intersection(set(new_item.multi_episodes)):
                itemlist.append(new_item)
        elif new_item.episode in multi_episodes:
            itemlist.append(new_item)

    return itemlist


def episodes(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)
    #logger.debug(data)

    patron = "<a href='(/serie-episodio-descargar-torrent[^']+)'>([^<]+)"
    for url, episode in scrapertools.find_multiple_matches(data, patron):
        new_item = item.clone(
            url=HOST + url,
            action="findvideos",
            content_type='servers'
        )

        num_episode = scrapertools.find_multiple_matches(episode, "\d+x(\d+)")
        if len(num_episode) == 1:
            itemlist.append(new_item.clone(episode = int(num_episode[0])))

        else:
            if 'al' in episode and len(num_episode) == 2:
                multi_episodes = range(int(num_episode[0]), int(num_episode[1]) + 1)
            else:
                multi_episodes = [int(n) for n in num_episode].sorted()

            for n in multi_episodes:
                itemlist.append(new_item.clone(episode=n))


    return itemlist


def findvideos(item):
    logger.trace()
    itemlist = list()

    data = httptools.downloadpage(item.url).data
    data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")
    data = re.sub(r"\n|\r|\t|&nbsp;|<br>", "", data)

    data_torrent = scrapertools.find_single_match(data, "Torrent:.*?<a href='(.*?)'")
    size = scrapertools.find_single_match(data, 'Tamaño:</b> (.*?) .*?<')

    # descargamos la siguiente pagina
    data = httptools.downloadpage(HOST + "/" + data_torrent).data
    #data = re.sub(r"\n|\r|\t|&nbsp;|<br>", "", data)

    itemlist.append(item.clone(
        size=(float(size.replace(',', '.')) * 1024 * 1024) if size else '',
        action="play",
        url= HOST + scrapertools.find_single_match(data, "Pincha <a href='(.*?)'>"),
        type='server',
        server='torrent'
    ))

    return servertools.get_servers_from_id(itemlist)
